using System;

namespace PathWords {

	public class NeighborEntry : Gtk.Entry {
		public NeighborEntry LeftNeighbor, RightNeighbor, TopNeighbor, BottomNeighbor;
		
		
		public NeighborEntry() {
			
		}
		
		protected override void OnBackspace ()
		{
			base.OnBackspace();
			Text = string.Empty;
		}

		
		protected override void OnTextInserted (string text, ref int position)
		{
			if (text.Equals(string.Empty) || !char.IsLetter(text.ToCharArray()[0])) {
				base.OnTextInserted(string.Empty, ref position);
				return;
			}
			
			if (text.ToUpper().Equals("Q")) {
				base.OnTextInserted("Qu", ref position);
			} else {
			    base.OnTextInserted(text.ToUpper(), ref position);
			}
		}

		
		protected override bool OnKeyPressEvent (Gdk.EventKey evnt)
		{
		 	switch(evnt.Key) {
			case Gdk.Key.Left :
				LeftNeighbor.GrabFocus();
				return true;
			
			case Gdk.Key.Right :
				RightNeighbor.GrabFocus();
				return true;
				
			case Gdk.Key.Up :
				TopNeighbor.GrabFocus();
				return true;
				
			case Gdk.Key.Down :
				BottomNeighbor.GrabFocus();
				return true;
							
			case Gdk.Key.Tab :
				return false;
			}
			
			return base.OnKeyPressEvent (evnt);
		}

	}
	
}