
using System;
using System.Collections.Generic;

namespace PathWords
{
	public class WordDictionary //: System.Collections.Generic.SortedList<string,string>
	{
		protected string[] wordBank;
		private int startIdx;
		private int bankLength;
		
		public WordDictionary(string fileName)
		{
			List<string> sortedBank = new List<string>();

			System.IO.StreamReader sr = System.IO.File.OpenText(fileName);
			while(!sr.EndOfStream) {
				string word = sr.ReadLine().ToUpper();
				sortedBank.Add(word);
			}
			
			wordBank = sortedBank.ToArray();
			startIdx = 0;
			bankLength = wordBank.Length;
		}
		
		public WordDictionary(WordDictionary dict, string prefix){
			wordBank = dict.wordBank;
			startIdx = findFirstIdx(wordBank, dict.startIdx, dict.bankLength, prefix);
			bankLength = findLastIdx(wordBank, dict.startIdx,
					dict.bankLength, prefix) - startIdx;

			/*
			Console.WriteLine("{0} words start with {1}", bankLength, prefix);
			if (bankLength <= 0) return;
			if (startIdx > 0) Console.WriteLine("\t{0}", wordBank[startIdx-1]);
			Console.WriteLine("\t---------------------------------------");
			if (bankLength > 0)   Console.WriteLine("\t{0}", wordBank[startIdx]);
			if (bankLength > 2)   Console.WriteLine("\t...");
			if (bankLength > 1)   Console.WriteLine("\t{0}", wordBank[startIdx+bankLength-1]);
			Console.WriteLine("\t---------------------------------------");
			if (startIdx+bankLength<wordBank.Length)
				          Console.WriteLine("\t{0}", wordBank[startIdx+bankLength]);
			*/
		}

		private int findFirstIdx(String[] words, int start, int length, string prefix) {
			int idx = Array.BinarySearch<String>(words,
					start, length, prefix);

			if (idx >= 0)
				return idx;
			else
				return ~idx;
		}

		private int findLastIdx(String[] words, int start, int length, string prefix) {
			int idx = Array.BinarySearch<String>(words,
					start, length, prefix+"ZZZZZZ");

			if (idx >= 0)
				return idx;
			else
				return ~idx;
		}

		public bool Contains(string word) {
			if (bankLength < 1) return false;
			return Array.BinarySearch<String>(wordBank, startIdx,
					bankLength, word) >= 0;
		}

		public int Count {
			get { return bankLength; }
		}
			
	}
}
