
using System;
using System.Collections.Generic;
namespace PathWords
{
	
	
	public class WordPath
	{
		public List<PathTile> TilePath;
		public bool IsEndPoint;
		public string currentWord;
		protected PathTile currentTile;
		WordDictionary possibleWords;
		
		public WordPath(WordDictionary dict, PathTile tile)
		{
			TilePath = new List<PathTile>();
			TilePath.Add(tile);
			
			currentTile = tile;
			currentWord = tile.Letter;
			
			possibleWords = new WordDictionary(dict, currentWord);
			IsEndPoint = false;
		}
		
		public WordPath(WordPath oldPath, PathTile tile) {
			TilePath = new List<PathTile>(oldPath.TilePath);
			TilePath.Add(tile);
			
			currentTile = tile;
			currentWord = oldPath.currentWord + tile.Letter;
			
			possibleWords = new WordDictionary(oldPath.possibleWords, currentWord);
			IsEndPoint = possibleWords.Contains(currentWord);
		}
		
		public WordPath FindLongestPath() {
			// Console.WriteLine("curPath:{0} ({1} possible)", currentWord, possibleWords.Count);
			
			WordPath maxPath = IsEndPoint ? this : null;
			int maxLength = PathLength(maxPath);
			
			if (possibleWords.Count == 0) return maxPath;
			
			foreach (PathTile neighbor in currentTile.Neighbors) {
				if (TilePath.Contains(neighbor)) continue;
				
				WordPath curPath = new WordPath(this, neighbor).FindLongestPath();
				if (PathLength(curPath) > maxLength) {
					maxPath = curPath;
					maxLength = PathLength(curPath);
				}
			}
			
			return maxPath;
		}
		
		public static int PathLength(WordPath path) { 
			if (path == null) return -1;		
			return path.TilePath.Count;
		}
	}
}
